codeforces 1003C Intense Heat

The heat during the last few days has been really intense. Scientists from all over the Berland study how the temperatures and weather change, and they claim that this summer is abnormally hot. But any scientific claim sounds a lot more reasonable if there are some numbers involved, so they have decided to actually calculate some value which would represent how high the temperatures are.

Mathematicians of Berland State University came up with a special heat intensity value. This value is calculated as follows:

Suppose we want to analyze the segment of nn consecutive days. We have measured the temperatures during these nn days; the temperature during ii-th day equals aiai.

We denote the average temperature of a segment of some consecutive days as the arithmetic mean of the temperature measures during this segment of days. So, if we want to analyze the average temperature from day xx to day yy, we calculate it as ∑i=xyaiy−x+1∑i=xyaiy−x+1 (note that division is performed without any rounding). The heat intensity value is the maximum of average temperatures over all segments of not less than kkconsecutive days. For example, if analyzing the measures [3,4,1,2][3,4,1,2] and k=3k=3, we are interested in segments [3,4,1][3,4,1], [4,1,2][4,1,2] and [3,4,1,2][3,4,1,2] (we want to find the maximum value of average temperature over these segments).

You have been hired by Berland State University to write a program that would compute the heat intensity value of a given period of days. Are you up to this task?

Input

The first line contains two integers nn and kk (1≤k≤n≤50001≤k≤n≤5000) — the number of days in the given period, and the minimum number of days in a segment we consider when calculating heat intensity value, respectively.

The second line contains nn integers a1a1, a2a2, ..., anan (1≤ai≤50001≤ai≤5000) — the temperature measures during given nn days.

Output

Print one real number — the heat intensity value, i. e., the maximum of average temperatures over all segments of not less than kk consecutive days.

Your answer will be considered correct if the following condition holds: |res−res0|<10−6|res−res0|<10−6, where resresis your answer, and res0res0 is the answer given by the jury's solution.

Example

Input

4 3
3 4 1 2

Output

2.666666666666667

题意:给出长为n的数列,表示有连续的n天,每天的温度为ai,现在,定义平均热度为

∑ai(i=x to y) / (y-x+1)

x,y表示任意从x天开始,到y天结束。k表示的是最短的连续天数,你的天数要 k<=t<=n  即  y-x+1>=k。

数列可能有多个平均热度,求出最大的平均热度

思路:

用到了前缀和,然后再去比较求出一个最大的

注意到长度 L 的变化是 k<=L<=n,当子序列同长度时,y-x+1 是相同的,并且就是 k,所以可以先求出来某一长度的最大和,再去除天数

需要注意的是输出结果,要保留 15位小数

Code:

#include<iostream>
#include<cmath>
#include<cstdlib>
#include<cstring>
#include<algorithm>
#include<queue>
#include<stack>
#include<vector>
#include<cstdio>
#include<cstdlib>

using namespace std;
#define eps 1e-9
int main()
{
    int n,k;
    int sum[5001];
    int x;
    int a,b,c,maxx=0;
    double ans[5001];
    cin>>n>>k;
    int flag=0;
    memset(sum,0,sizeof(sum));
    sum[0]=0;
    for(int i=1;i<=n;i++){
        scanf("%d",&x);
        sum[i]=sum[i-1]+x; // 求前缀和
    }
    for(int i=k;i<=n;i++)
    {
        maxx=0;
        if(i==n)
        {
            ans[flag++]=(double)sum[n]/n;
        }
        else{
            a=i;
            b=0;
            while(a<=n){
                c=sum[a]-sum[b];
                if(c>maxx)
                {
                    maxx=c;  //求得每一长度时和的最大值
                }
                a++;
                b++;
            }
            ans[flag++]=(double)maxx/i; // 带入公式记入结果数组中
        }
    }
    double maxx1=-1;
    for(int i=0;i<flag;i++)
    {
        if(ans[i]-maxx1>eps) // 对结果数组中的数求一个最大的,由于浮点数是高度精确的,所以定义一个 eps,精确值
            maxx1=ans[i];
    }
    printf("%.15f",maxx1);

}

 

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值